unit mainunit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Math, ComCtrls, Buttons, Menus;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    GroupBox1: TGroupBox;
    OpenDialog1: TOpenDialog;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    SaveDialog1: TSaveDialog;

    procedure Button1Click(Sender: TObject);
    procedure speichern;

  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{ TForm1 }


Var
  d1d: File;

  x,y,x1,x2,y1,y2,dx,dy,x0,y0,Gatetime,xydist,cpshigh,cpslow,alpha,startangle:array[0..99] of double;
  usr1:array[0..99] of double;
  creg1,creg2,creg3,creg4,creg5,creg6,creg7,creg8:array[0..99] of byte;
  scanmarker,points:array[0..99] of smallint;
  Energy,Focus1,current,usr2,usr3,focus2,extractor,dummy3:array[0..99] of double;
  usr4:array[0..99] of double;
  dateofscan:array[0..99] of string[20];
  comment:array[0..99] of string[100];
  scanfield:array[0..99] of array[1..2048] of double;
  dateiname:array[0..99] of string;
  anzahldateien:integer;
  geoffnet:boolean;


procedure TForm1.Button1Click(Sender: TObject);
var i:integer;
begin
  If OpenDialog1.Execute Then
   with OpenDialog1.Files do
    for I := 0 to Count - 1 do begin
    anzahldateien:=count-1;
    AssignFile(d1d,Strings[I]);
    dateiname[i]:=strings[i];
    Reset(d1d,1);
    Seek(d1d,0);
    Blockread(d1d,X[I],8);
    Blockread(d1d,y[I],8);
    Blockread(d1d,X1[I],8);
    Blockread(d1d,y1[I],8);
    Blockread(d1d,x2[I],8);
    Blockread(d1d,y2[I],8);
    Blockread(d1d,dx[I],8);
    Blockread(d1d,dy[I],8);
    Blockread(d1d,X0[I],8);
    Blockread(d1d,y0[I],8);
    Blockread(d1d,gatetime[I],8);
    Blockread(d1d,xydist[I],8);
    Blockread(d1d,cpshigh[I],8);
    Blockread(d1d,cpslow[I],8);
    Blockread(d1d,alpha[I],8);
    Blockread(d1d,startangle[I],8);

    Blockread(d1d,usr1[I],8);

    Blockread(d1d,Creg1[I],1);
    Blockread(d1d,Creg2[I],1);
    Blockread(d1d,creg3[I],1);
    Blockread(d1d,Creg4[I],1);
    Blockread(d1d,Creg5[I],1);
    Blockread(d1d,creg6[I],1);
    Blockread(d1d,Creg7[I],1);
    Blockread(d1d,creg8[I],1);

    Blockread(d1d,Scanmarker[I],2);
    Blockread(d1d,Points[I],2);

    Blockread(d1d,energy[I],8);
    Blockread(d1d,focus1[I],8);
    Blockread(d1d,current[I],8);
    Blockread(d1d,usr2[I],8);
    Blockread(d1d,usr3[I],8);
    Blockread(d1d,focus2[I],8);
    Blockread(d1d,extractor[I],8);
    Blockread(d1d,dummy3[I],8);

    Blockread(d1d,usr4[I],8);

    Blockread(d1d,dateofscan[I],20);

    Blockread(d1d,comment[I],100);

    Seek(d1d,358);

    BlockRead(d1d,scanfield[I],8*(points[I]+1));

    CloseFile(d1d);
    geoffnet:=true;
    end;
   if geoffnet then speichern;
end;

procedure TForm1.speichern;
Var ascii,ascii2: TextFile;
    i,j:integer;
    nameasc,nameascinfo:string;
begin
 for j:=0 to anzahldateien do begin
 nameasc:=dateiname[j]+'.txt';
 nameascinfo:=dateiname[j]+'.info';
 AssignFile(ascii,nameasc);
    Rewrite(ascii);
    If RadioButton2.Checked then begin
     Write(ascii,'X: ',floattostr(X[j]));
      WriteLn(ascii);
      Write(ascii,'Y: ',floattostr(Y[j]));
      WriteLn(ascii);
      Write(ascii,'X1: ',floattostr(x1[j]));
      WriteLn(ascii);
      Write(ascii,'Y1: ',floattostr(y1[j]));
      WriteLn(ascii);
      Write(ascii,'X2: ',floattostr(x2[j]));
      WriteLn(ascii);
      Write(ascii,'Y2: ',floattostr(y2[j]));
      WriteLn(ascii);
      Write(ascii,'X0: ',floattostr(x0[j]));
      WriteLn(ascii);
      Write(ascii,'Y0: ',floattostr(y0[j]));
      WriteLn(ascii);

      Write(ascii,'gatetime: ',floattostr(gatetime[j]));
      WriteLn(ascii);
      Write(ascii,'xyDist: ',floattostr(xydist[j]));
      WriteLn(ascii);
      Write(ascii,'CpsHigh: ',floattostr(cpshigh[j]));
      WriteLn(ascii);
      Write(ascii,'CpsLow: ',floattostr(cpslow[j]));
      WriteLn(ascii);
      Write(ascii,'angle: ',floattostr(alpha[j]));
      WriteLn(ascii);
      Write(ascii,'startangle: ',floattostr(startangle[j]));
      WriteLn(ascii);
      Write(ascii,'usr1: ',floattostr(usr1[j]));
      WriteLn(ascii);
      Write(ascii,'Creg1: ',inttostr(Creg1[j]));
      WriteLn(ascii);
      Write(ascii,'Creg2: ',inttostr(Creg2[j]));
      WriteLn(ascii);
      Write(ascii,'Creg3: ',inttostr(Creg3[j]));
      WriteLn(ascii);
      Write(ascii,'Creg4: ',inttostr(Creg4[j]));
      WriteLn(ascii);
      Write(ascii,'Creg5: ',inttostr(Creg5[j]));
      WriteLn(ascii);
      Write(ascii,'Creg6: ',inttostr(Creg6[j]));
      WriteLn(ascii);
      Write(ascii,'Creg7: ',inttostr(Creg7[j]));
      WriteLn(ascii);
      Write(ascii,'Creg8: ',inttostr(Creg8[j]));
      WriteLn(ascii);

      Write(ascii,'Scanmarker: ',inttostr(scanmarker[j]));
      WriteLn(ascii);
      Write(ascii,'Points : ',inttostr(points[j]));
      WriteLn(ascii);
      Write(ascii,'energy: ',floattostr(energy[j]));
      WriteLn(ascii);
      Write(ascii,'focus: ',floattostr(focus1[j]));
      WriteLn(ascii);
      Write(ascii,'current: ',floattostr(current[j]));
      WriteLn(ascii);
      Write(ascii,'usr2: ',floattostr(usr2[j]));
      WriteLn(ascii);
      Write(ascii,'usr3: ',floattostr(usr3[j]));
      WriteLn(ascii);
      Write(ascii,'focus2: ',floattostr(focus2[j]));
      WriteLn(ascii);
      Write(ascii,'extractor: ',floattostr(extractor[j]));
      WriteLn(ascii);
      Write(ascii,'dummy3: ',floattostr(dummy3[j]));
      WriteLn(ascii);
      Write(ascii,'usr4: ',floattostr(usr4[j]));
      WriteLn(ascii);
      Write(ascii,'dateofscan: ',dateofscan[j]);
      WriteLn(ascii);
      Write(ascii,'comment: ',comment[j]);
      WriteLn(ascii);
    end;
    For i:=0 To points[j] Do Begin
      Write(ascii,floattostr((-xydist[j]/2+i*xydist[j]/points[j])),'      ',scanfield[j][i+1]);
      WriteLn(ascii);
    End;
    CloseFile(ascii);

   if radiobutton3.Checked then begin
    AssignFile(ascii2,nameascinfo);
    Rewrite(ascii2);
      Write(ascii2,'X: ',floattostr(X[j]));
      WriteLn(ascii2);
      Write(ascii2,'Y: ',floattostr(Y[j]));
      WriteLn(ascii2);
      Write(ascii2,'X1: ',floattostr(x1[j]));
      WriteLn(ascii2);
      Write(ascii2,'Y1: ',floattostr(y1[j]));
      WriteLn(ascii2);
      Write(ascii2,'X2: ',floattostr(x2[j]));
      WriteLn(ascii2);
      Write(ascii2,'Y2: ',floattostr(y2[j]));
      WriteLn(ascii2);
      Write(ascii2,'X0: ',floattostr(x0[j]));
      WriteLn(ascii2);
      Write(ascii2,'Y0: ',floattostr(y0[j]));
      WriteLn(ascii2);

      Write(ascii2,'gatetime: ',floattostr(gatetime[j]));
      WriteLn(ascii2);
      Write(ascii2,'xyDist: ',floattostr(xydist[j]));
      WriteLn(ascii2);
      Write(ascii2,'CpsHigh: ',floattostr(cpshigh[j]));
      WriteLn(ascii2);
      Write(ascii2,'CpsLow: ',floattostr(cpslow[j]));
      WriteLn(ascii2);
      Write(ascii2,'angle: ',floattostr(alpha[j]));
      WriteLn(ascii2);
      Write(ascii2,'startangle: ',floattostr(startangle[j]));
      WriteLn(ascii2);
      Write(ascii2,'usr1: ',floattostr(usr1[j]));
      WriteLn(ascii2);
      Write(ascii2,'Creg1: ',inttostr(Creg1[j]));
      WriteLn(ascii2);
      Write(ascii2,'Creg2: ',inttostr(Creg2[j]));
      WriteLn(ascii2);
      Write(ascii2,'Creg3: ',inttostr(Creg3[j]));
      WriteLn(ascii2);
      Write(ascii2,'Creg4: ',inttostr(Creg4[j]));
      WriteLn(ascii2);
      Write(ascii2,'Creg5: ',inttostr(Creg5[j]));
      WriteLn(ascii2);
      Write(ascii2,'Creg6: ',inttostr(Creg6[j]));
      WriteLn(ascii2);
      Write(ascii2,'Creg7: ',inttostr(Creg7[j]));
      WriteLn(ascii2);
      Write(ascii2,'Creg8: ',inttostr(Creg8[j]));
      WriteLn(ascii2);

      Write(ascii2,'Scanmarker: ',inttostr(scanmarker[j]));
      WriteLn(ascii2);
      Write(ascii2,'Points : ',inttostr(points[j]));
      WriteLn(ascii2);
      Write(ascii2,'energy: ',floattostr(energy[j]));
      WriteLn(ascii2);
      Write(ascii2,'focus: ',floattostr(focus1[j]));
      WriteLn(ascii2);
      Write(ascii2,'current: ',floattostr(current[j]));
      WriteLn(ascii2);
      Write(ascii2,'usr2: ',floattostr(usr2[j]));
      WriteLn(ascii2);
      Write(ascii2,'usr3: ',floattostr(usr3[j]));
      WriteLn(ascii2);
      Write(ascii2,'focus2: ',floattostr(focus2[j]));
      WriteLn(ascii2);
      Write(ascii2,'extractor: ',floattostr(extractor[j]));
      WriteLn(ascii2);
      Write(ascii2,'dummy3: ',floattostr(dummy3[j]));
      WriteLn(ascii2);
      Write(ascii2,'usr4: ',floattostr(usr4[j]));
      WriteLn(ascii2);
      Write(ascii2,'dateofscan: ',dateofscan[j]);
      WriteLn(ascii2);
      Write(ascii2,'comment: ',comment[j]);
      WriteLn(ascii2);
    CloseFile(ascii2);
    end;
 end;
end;



initialization
  {$I mainunit.lrs}

end.

